/*------------------------------------------------------------------------
Apo to Biblio:
I.Vlahavas, P.Kefalas, N.Basileiadis, F.Kokkoras, I.Sakellariou
Texnhth Nohmosunh (B' Ekdosh), Ekdoseis Gartaganh, Thessaloniki, 2005
http://aibook.csd.auth.gr
------------------------------------------------------------------------*/
/*---------------------------------------------------------------------
Auxiliary Definitions for reading a sentence from std input
      (adapted from Clocksin & Mellish book)

Example:
?- read(S).
   (:sender agent1 :language prolog :content "p(X)").
   S=['(',':sender',agent1,':language',prolog,':content','p(X)',')'].

Notes:
- for use in KQML parsing
- keeps the character ':' with the following word
- all upper case letters (except in "") are transformed in lower case
---------------------------------------------------------------------*/

reads(S):-
	read_in(L),
	append(S,['.'],L),!.

read_in([W|Ws]):-
	get0(C),
	readword(C, W, C1),
	restsent(W, C1, Ws), !. 

restsent(W, _, []):-
	lastword(W), !.
restsent(_, C, [W1|Ws]):-
	readword(C, W1, C1),
	restsent(W1, C1, Ws).

readword(C, W, C2):-
	string_character(C), !,
	get0(C1),
	restwordinstring(C1,Cs),
	name(W,Cs),
	get0(C2).
readword(C, W, C1):-
	single_character(C), !,
	name(W, [C]),
	get0(C1).
readword(C, W, C2):-
	in_word(C, NewC), !,
	get0(C1),
	restword(C1, Cs, C2),
	name(W, [NewC|Cs]).
readword(_, W, C2):-
	get0(C1),
	readword(C1, W, C2).

restword(C, [NewC|Cs], C2):-
	in_word(C, NewC), !,
	get0(C1),
	restword(C1, Cs, C2).
restword(C, [], C).

restwordinstring(C,[]):-
	string_character(C),!.
restwordinstring(C,[C|R]):-
	get0(NC),
	restwordinstring(NC,R).

string_character(34). 	% "
single_character(33).	% !
single_character(35).	% #
single_character(39).	% '
single_character(40).	% (
single_character(41).	% )
single_character(42).	% *
single_character(43).	% +
single_character(44).	% ,
single_character(46).	% .
single_character(47).	% /
single_character(59).	% ;
single_character(60).	% <
single_character(61).	% =
single_character(62).	% >
single_character(63).	% ?
single_character(91).	% [
single_character(93).	% ]
single_character(94).	% ^
single_character(123).	% {
single_character(124).	% |
single_character(125).	% }

in_word(C, C):-
	C>96, C<123.
in_word(C, L):-
	C>64, C<91,
	L is C+32.
in_word(C, C):-
	C>47, C<58.
in_word(95, 95).% _
in_word(58,58). % :
in_word(92,92). % \
in_word(45,45).	% -

lastword('.').


